 #!/bin/sh
#create .jwmrc-drives to reflect drives/partitions present. by goingnuts
#- thanks to sc0ttman for improving the coding
# get PDEV1 and PUP_HOME from PUPSTATE  
. /etc/rc.d/PUPSTATE
#PDEV1 gives boot media
#PUPSAVE gives partition with savefile ex. "sda2,ext2,/pup_save-test.2fs"

echo "<JWM>
<Tray layout=\"horizontal\" x=\"-38\" y=\"-78\" height=\"40\" layer=\"0\" border=\"1\">
" > /root/.jwmrc-drives

for PART in $(fdisk -l | grep "/dev/" | grep -v "Disk" | cut -d " " -f 1); do
  # set the default icon, for standard drives
  ICON="drive"
	
  TYPE="$(guess_fstype "${PART}" 2>/dev/null)"
  if [ ! "${TYPE}" = "unknown" ] && [ ! "${TYPE}" = "swap" ]; then
    # set mount path
    MNTPATH="$(echo $PART | sed 's/\/dev\///g')"
    # check for usb drives
    USBCHK=""
    USBCHK=$(probedisk2 | grep "usbdrv" | grep "${MNTPATH:0:3}" )
    # if USB partition, change icon
    [ "$USBCHK" != "" ] && ICON="usbdrv"
    LABEL="$(echo $PART | sed 's/\/dev\///g')"
    # if mnt path found is PDEV1, replace with PUP_HOME or /mnt/home, works with automount
    if [ "$MNTPATH" = "$PDEV1" ] || [ "$MNTPATH" = "$(echo $PUPSAVE | cut -d "," -f1)" ]; then # if current partition contains the pup_*.sfs file
      # set icon as unmountable partition
      ICON="${ICON}_mntd_boot"
      if [ $PUPMODE = 12 ] || [ $PUPMODE = 13 ]; then # if save file is in use
        # save file is being used, use /mnt/home
        MNTPATH="$(readlink /mnt/home)"
        echo "<TrayButton popup=\"${LABEL}, ${TYPE}\" icon=\"${ICON}48.png\">exec: defaultfilemanager $MNTPATH</TrayButton>" >> /root/.jwmrc-drives
      else # no save file being used
        MNTPATH=$(mount | grep '/initrd/mnt/dev_ro' | cut -f 3 -d ' ') # get the mounted ro loop in initrd (bad hack, I think!)
        if [ "$MNTPATH" = "" ]; then # if mnt path above is not found
          # usr default mount path (required for some newer pups.. later than 4.2)
          MNTPATH="$(echo $PART | sed 's/\/dev\///g')" # set mount point as normal, if nothing was found at /initrd/mnt/dev_ro*/ 
          
          echo "<TrayButton popup=\"${LABEL}, ${TYPE}\" icon=\"${ICON}48.png\">exec:/root/drive_mounter.sh ${MNTPATH}</TrayButton>" >> /root/.jwmrc-drives
        else # unmountable mount point already.. just open with rox
          echo "<TrayButton popup=\"${LABEL}, ${TYPE}\" icon=\"${ICON}48.png\">exec: defaultfilemanager ${MNTPATH}</TrayButton>" >> /root/.jwmrc-drives
        fi
      fi
    else # not the pup_*.sfs partition, open normal mount point
      echo "<TrayButton popup=\"${LABEL}, ${TYPE}\" icon=\"${ICON}48.png\">exec:/root/drive_mounter.sh ${MNTPATH}</TrayButton>" >> /root/.jwmrc-drives
    fi
  fi
done

#240511 changed to work on old kernels too
if [ -e /proc/ide ]; then #old kernel device naming
  DEVICE="hdc"
else
  DEVICE="sr0"
fi

ISBOOTCD=$(mount | grep "${DEVICE}" | grep "/initrd/mnt/" )
if [ ! "${ISBOOTCD}" = "" ]; then
  ICON="optical_mntd_boot"
else
  ICON="optical"
fi


echo "<TrayButton popup=\"$DEVICE, iso9660\" icon=\"${ICON}48.png\">exec:/root/cd_mounter.sh</TrayButton>
<TrayButton popup=\"fd0\" icon=\"floppy48.png\">exec:/root/floppy_mounter.sh</TrayButton>
</Tray>
</JWM>" >> /root/.jwmrc-drives