#!/bin/sh
#set jwm desktop background
#.jwmrc-desktop contains code for desktops. Is included in .jwmrc

clear

TYPE="cli"		#dialog or cli
[ $(which dialog) ] && TYPE="dialog" && DIALOG=dialog
[ $(which Xdialog) ] && [ ! "$(ps | grep xwin)" = "" ] && DIALOG=Xdialog

if [ $(which dialogfunctions.sh) ]; then #check functions present
INCLUDE=$(which dialogfunctions.sh)
else
echo "You are missing file 'dialogfunctions.sh'.
Program will not run without it."
exit
fi

CURDIR=$(pwd)
. "${INCLUDE}"	#contains functions used for the dialogs

TITLE="JWM SET BACKGROUND"

choice_color_new () {
# choose colour, only named X-colours present.
#The text form of this database is commonly stored in the file /usr/X11R7/lib/X11/rgb.txt.
#using colours in /usr/X11R7/lib/X11/rgb.txt
LIST=$(cat /usr/X11R7/lib/X11/rgb.txt | grep -v "Xorg" | sed 's/\t/_/g' | cut -d "_" -f 3 > /tmp/test)

TEXT="Please select a colour"

echo -n > /tmp/choices
echo -n > /tmp/select
COUNTER=0

#write CHOICES to file
cat /tmp/test | while read COLOUR; do
if [ ! "${COLOUR}" = "" ]; then
echo "${COLOUR}" >> /tmp/choices
#create response file
echo "${COUNTER}) ${COLOUR}" >> /tmp/select
let COUNTER=COUNTER+1 
fi
done

#run...
menu_fc
#evaluate response
echo $REPLY_CHAR > /tmp/colour
}

#MAIN PROGRAM
TEXT="Setting background/wallpaper on your jwm-desktop.
What type of background do you want to use?"
#write CHOICES to file

echo "Solid (A solid color)
Gradient (A gradient color)
Image (A stretched image)
Tile (A tiled image)
Command (A command to be run for setting the background)
None (No background)
Cancel (Quit without changing anything)" >/tmp/choices

#run...
menu_fc

#evaluate response
case $REPLY_NUM in
   0)   choice_color_new
		COLOUR=$(cat /tmp/colour)
		echo "<JWM>
		<Desktops count=\"2\">
		<Desktop>
		<Background type=\"solid\">$COLOUR</Background>
		</Desktop>
		</Desktops>
		</JWM>
		" > /root/.jwmrc-desktop
		break;;
	1)	choice_color_new
		COLOUR1=$(cat /tmp/colour)
		#choice_color
		choice_color_new
		COLOUR2=$(cat /tmp/colour)
		echo "<JWM>
		<Desktops count=\"2\">
		<Desktop>
		<Background type=\"gradient\">$COLOUR1:$COLOUR2</Background>
		</Desktop>
		</Desktops>
		</JWM>" > /root/.jwmrc-desktop
		break;;
	2)	TEXT="Enter full path to image"
		#run...
		fileselect_fc
		#evaluate response
		if [ "${REPLY_CHAR}" = "cancel" ];then
		  break
		else
		echo "<JWM>
		<Desktops count=\"2\">
		<Desktop><Background type=\"image\">$REPLY_CHAR</Background></Desktop>
		</Desktops>
		</JWM>
		" > /root/.jwmrc-desktop && break
		fi
		;;
	3) 	TEXT="Enter full path to image"
		#run...
		fileselect_fc
		#evaluate response
		if [ "${REPLY_CHAR}" = "cancel" ];then
		  break
		else
		echo "<JWM>
		<Desktops count=\"2\">
		<Background type=\"tile\">$REPLY_CHAR</Background>
		</Desktops>
		</JWM>" > /root/.jwmrc-desktop && break
		fi
		;;
	4)	TEXT="Enter command to run"
		#run...
		fileselect_fc
		#evaluate response
		if [ "${REPLY_CHAR}" = "cancel" ];then
		  break
		else
		echo "<JWM>
		<Desktops count=\"2\">
		<Background type=\"command\">$REPLY_CHAR</Background>
		</Desktops>
		</JWM>" > /root/.jwmrc-desktop && break
		fi
		;;
	5)	echo "<JWM>
		<Desktops count=\"2\">
		</Desktops>
		</JWM>
		" > /root/.jwmrc-desktop; break;;
	6)  exit;;

esac

if [ "${REPLY_CHAR}" = "cancel" ]; then
TEXT="Canceled - nothing has been changed."
message_fc
else
jwm -restart
TEXT="Your desktop background has been changed."
message_fc
fi

# clean up
rm -f /tmp/select
rm -f /tmp/colour
rm -f /tmp/colour.sh
rm -f /tmp/test
exit
